mod Ex02b

incl Mtex

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 19.2.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a definiciam predikatov. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_n_char_even
  Prefix(100,2,Subsup(Id(1,'Even',0),75,Op('*',0),None),Arg(0))

appldisp/1 Tex_f1_n_char_odd
  Prefix(100,2,Subsup(Id(1,'Odd',0),75,Op('*',0),None),Arg(0))

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Definitions of Predicates.  \end 

rem 
  \para \bf  Subsection. Explicit Definitions of Predicates.  \end 

rem 
  \para \bf  Bounded formulas.  \end 

rem 
  \para \bf  [CL] Syntax.  \end Examples: 
  \items 
   \item \para Atomic formulas: \ft x = y \end, \ft R(x) \end. 
   \item \para Propositional connectives: \ft \t \end, \ft \f \end, \ft ~R \end, 
         \ft R & Q \end, \ft R \/ Q \end, \ft R -> Q \end, \ft R <-> Q \end. 
   \item \para Bounded quantification: \ft \eb y y <= x: R \end, 
         \ft \ab y y <= x: R \end, \ft \eb y y < x: R \end, 
         \ft \ab y y < x: R \end. 
   \item \para Notational conventions: \ft x != y \end, \ft x <= y \end, 
         \ft x < y \end, \ft x > y \end, \ft x >= y \end. 
  \end

rem 
  \para \bf  Explicit definitions of predicates with bounded formulas.  \end 

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 Q  \end Examples: 
  \def 
    pred R 
    R(x) <-> \eb y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> \eb y y < x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y < x: Q(x,y)
  \end

rem 
  \para \bf  \ft Tex0_sigma0 \end-predicates.  \end 
  \ft Tex0_sigma0 \end-predicates are defined by bounded formulas in the 
  language of first-order arithmetic (decimal constants, addition, 
  multiplication, comparision predicates). 

rem 
  \para \bf  Divisibility.  \end Find a \ft Tex0_sigma0 \end-definition of the 
  divisibility predicate. 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> Poo

rem 
  \para \bf  Primes.  \end Show that the predicate \ft Prime(x) \end holding of 
  prime numbers is a \ft Tex0_sigma0 \end-predicate. 

pred Prime 
  Prime(x) <-> Poo

rem 
  \para \bf  Powers of two.  \end Show that the predicate 
  \eq* 
    Pow2(x) <-> \e n x = Tex_f2_n_exp(2,n)
  \end
  \para is a \ft Tex0_sigma0 \end-predicate. 

pred Pow2 
  Pow2(x) <-> Poo

rem 
  \para \bf  Powers of four.  \end Show that the predicate 
  \eq* 
    Pow4(x) <-> \e n x = Tex_f2_n_exp(4,n)
  \end
  \para is a \ft Tex0_sigma0 \end-predicate. 

pred Pow4 
  Pow4(x) <-> Poo

rem 
  \para \bf  Powers of a prime.  \end \header* pred/2 Power_of_the_prime  \end 
  Show that there is a binary \ft Tex0_sigma0 \end-predicate 
  \ft Power_of_the_prime(x,p) \end such that 
  \eq* 
    Prime(p) -> Power_of_the_prime(x,p) <-> \e n x = Tex_f2_n_exp(p,n)
  \end

pred/2 Power_of_the_prime 
  Power_of_the_prime(x,p) <-> Poo

rem 
  \para \bf  Powers of primes.  \end Show that the predicate 
  \eq* 
    Power_of_some_prime(x) <-> \e p(Prime(p) & \e n x = Tex_f2_n_exp(p,n))
  \end
  \para is a \ft Tex0_sigma0 \end-predicate. 

pred Power_of_some_prime 
  Power_of_some_prime(x) <-> Poo

rem 
  \para \bf  Subsection. Recursive Definitions of Predicates.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun Evenf 'Tex_f1_n_char_even' \end Find a 
  primitive recursive definition of the characteristic function 
  \ft Evenf(x) \end of the predicate 
  \eq* 
    Even(x) <-> \e y x = 2*y
  \end
  \para which is based on the property 
  \eq* 
    Even(x) <-> x = 0 \/ \e y(x = y+1 & ~Even(y))
  \end
  \para Do not use default clauses! 

fun Evenf 'Tex_f1_n_char_even'
  Evenf(x) = Foo

rem 
  \para \bf  Exercise.  \end Transform the above function clausal definition to 
  predicate clausal definition. 
  \para \it  Hint.  \end Recall that we have 
  \eq* 
    Even(x) <-> Evenf(x) = 1 & Even(x) <-> Evenf(x) != 0
  \end
  \eq* 
    ~Even(x) <-> Evenf(x) = 0 & ~Even(x) <-> Evenf(x) != 1
  \end

pred Even 
  Even(x) <- Poo

rem 
  \para \bf  Exercise.  \end \header* fun Oddf 'Tex_f1_n_char_odd' \end Find a 
  primitive recursive definition of the characteristic function \ft Oddf(x) \end 
  of the predicate 
  \eq* 
    Odd(x) <-> \e y x = 2*y+1
  \end
  \para which is based on the property 
  \eq* 
    Odd(x) <-> x = 1 \/ \e y(x = y+2 & Odd(y))
  \end
  \para Do not use default clauses! 

fun Oddf 'Tex_f1_n_char_odd'
  Oddf(x) = Foo

rem 
  \para \bf  Exercise.  \end Transform the above function clausal definition to 
  predicate clausal definition. 

pred Odd 
  Odd(x) <- Poo

